package video.pano.pano_rtc

import android.app.Activity
import android.content.Context
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import io.flutter.plugin.common.EventChannel
import io.flutter.plugin.common.MethodChannel

class PanoRtcPlugin : FlutterPlugin, ActivityAware {

    companion object {
        lateinit var binding: FlutterPlugin.FlutterPluginBinding
        lateinit var engineManager: RtcEngineManager
        lateinit var appContext: Context
        var activity: Activity? = null

        fun createMethodChannel(name: String): MethodChannel {
            return MethodChannel(binding.binaryMessenger, name)
        }

        fun createEventChannel(name: String): EventChannel {
            return EventChannel(binding.binaryMessenger, name)
        }
    }

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        binding = flutterPluginBinding
        appContext = flutterPluginBinding.applicationContext
        flutterPluginBinding.platformViewRegistry.registerViewFactory("PanoNativeView",
                PanoNativeViewFactory())
        flutterPluginBinding.platformViewRegistry.registerViewFactory("PanoWhiteboardNativeView",
                PanoWhiteboardNativeViewFactory())
        engineManager = RtcEngineManager()
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        engineManager.onDetachedFromEngine()
    }

    override fun onDetachedFromActivity() {
        activity = null
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {
        activity = binding.activity
    }

    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        activity = binding.activity
    }

    override fun onDetachedFromActivityForConfigChanges() {
        activity = null
    }
}


